<%@page pageEncoding="UTF-8"%>
<%@page import="java.util.ResourceBundle" %>
<%@page import="java.util.Locale" %>
<%@page import="java.util.MissingResourceException"%>
<%@page import="java.util.List"%>
<%@page import="java.text.MessageFormat" %>
<%@page import="java.lang.reflect.Method" %>
<%
    Locale currentLocale = request.getLocale();
    //System.out.println("Locale: " + currentLocale.toString());
    String localeStr = currentLocale.getLanguage()+"-" +currentLocale.getCountry().toLowerCase();
    //this attribute is being set by the caller
    String invalidPermission = "";
    String userID="${userID}";
    invalidPermission = getMessage("invalidPermission", currentLocale);
    invalidPermission = MessageFormat.format(invalidPermission, userID);
    String path = null;
    //retrieve the previous path - request.getRequestURI will return path of the login.jsp file
    Object prevPath = request.getAttribute("javax.servlet.forward.request_uri");
    String referer = request.getHeader("referer");
    if (referer == null) {
        if(prevPath != null){
            path = prevPath.toString();
        }
    }
    else {
        path = referer;
    }

    //For Websphere, after user is redirected to login page from logout page, the browser refreshes every 10 minutes. In that case, 
    //browser shows the referer to be login.jsp instead of admin/console. So instead of title showing as OCM/Manager, it shows as Application Call
    if(path == null || (path != null && path.indexOf("login.jsp") != -1)){//For Websphere: both javax.servlet.forward.request_uri and referer seems to return null. But works for wasce.
	    Cookie[] cookies = request.getCookies();
	    if(cookies != null){
		    for(Cookie c: cookies){
		        if(c.getName().equalsIgnoreCase("WASReqURL")){
		        	String originalPath = c.getValue();
		        	int index = originalPath.indexOf("/optim");
		        	if(index != -1){
		        		path = originalPath.substring(index);
		        	}
		        }
		    }
	    }
    }
    if(path == null || (path != null && path.indexOf("/optim/") == -1)){
        path = request.getRequestURL().toString();
        if(path == null){
            path = request.getContextPath() + "/admin";
        }
    }

    String ocmTitle = getMessage("productTitle", currentLocale);
    String mgrTitle = getMessage("managerProductTitle", currentLocale);
    String applicationTitle = getMessage("applicationCallTitle", new Locale("en", "US"));

    response.setHeader("X-Frame-Options", "SAMEORIGIN");
    response.setHeader("Cache-Control", "no-store");
    response.setHeader("Pragma", "no-store");
%>
<%! 
private String getMessage(String key, Locale locale) {
    //Locale currentLocale = request.getLocale();
    ResourceBundle messages = ResourceBundle.getBundle("com.ibm.nex.dsi.ui.nls.resources", locale);
    String msg = key;
    try {
        msg = messages.getString(key);
    }catch (MissingResourceException e2) {
            String exMsg = "Login E2:Cannot get value for "+key+" in " + locale.toString() +".";
            new Exception(exMsg,e2).printStackTrace();
    }catch (Exception e) {
        String exMsg = "Login E:Cannot get value for "+key+" in " + locale.toString()+".";
        new Exception(exMsg,e).printStackTrace();
    }
    return msg;
}

%>
<!DOCTYPE HTML>
<!-- 
* IBM Confidential
* OCO Source Materials
* 5724-U98, 5655-V48, 5724-U50, 5655-V46
* © Copyright IBM Corp. 2013
* The source code for this program is not published or other -
* wise divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
*
 -->
<html>
<head>
<title></title>
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dojo/resources/dojo.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dijit/themes/dijit.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/dojo_1.8.1/dijit/themes/dijit_rtl.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/idx/widget/commonMessageIcons.css">
<link rel="stylesheet" href="<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/oneui.css">
<style type="text/css">
	html, body {
		background-color:#C0C0C0;
		background-image: url('<%=request.getContextPath()%>/images/login_bkgrd.png');
		background-size: cover;
		width: 100%;
		height: 100%;
		margin: 0;
		overflow:hidden;
	}
	
	.pageOverlay {
	    top: 0;
	    left: 0;
	    position: absolute;
	    height: 100%;
	    width: 100%;
	    z-index: 1001;
	    display: block;
	}
	 
	#loadingDiv {
		background-color: #fff;
	    background-image: url('<%=request.getContextPath()%>/dojo/ibmjs/idx/themes/oneui/idx/images/loadingAnimation38px.gif');
	    background-repeat: no-repeat;
	    background-position: center;
	}
	
	.oneui .idxLoginFrameBox {
		width:270px;
	
	    padding:50px 50px;
	
	    border: solid 3px #999999;
	
		-webkit-box-shadow: 0px 0px 3px #000000;
		-moz-box-shadow: 0px 0px 3px #000000;
		box-shadow: 0px 0px 3px #000000;
		
		border-radius: 3px;
	
		background:#ffffff;
	
		margin: 100px auto 0;
	}
	
	.ibmLogo {
		display: block;
		width: 85px;
		height: 30px;
		background-image: url('<%=request.getContextPath()%>/images/ibmLogoDark.png');
		background-repeat: no-repeat;
		margin-bottom: 20px;
	}
</style>
<script>
var dojoConfig = {
    async: true, 
    locale: "<%=localeStr%>",
    has: {
        "dojo-firebug": true,
        "dojo-debug-messages": true
    },
    packages: [
        {name: "idx", location: "../../ibmjs/idx"}
    ]
};
</script>
<script src='<%=request.getContextPath()%>/dojo/dojo_1.8.1/dojo/dojo.js'></script>
<script type="text/javascript">
var invalidPermission = "<%=invalidPermission%>";
require([
	"dojo/parser",
	"dojo/on",
	"dojo/string",
	"dijit/registry",
	"dojo/ready",
	"dijit/layout/ContentPane",
	"idx/layout/BorderContainer",
	"idx/form/TextBox",
	"dijit/form/Button",
	"idx/form/buttons",
	"dojo/domReady!"],
	function(dParser, dom, string, registry, ready) {
	    //alert("hash: " + window.location.hash);
	    var hash = window.location.hash;
	    var user = "";
	    if (hash) {
	        user = hash.substring(1);//skip the hash sign
	        invalidPermission = string.substitute(invalidPermission, {'userID': user});
	    }
	    //remove any fragments
	    window.location.hash = "";
		dParser.parse(); // parse declarative widgets
		preLoader.loadComplete();
		ready(function(){
		    if (user) {
	            populateResultMessage("oneuiMsgError16", invalidPermission, "messageDiv");
	            registry.byId('username').set('value', user);
	        }
		});
		var refreshInterval = 10 * 60 * 1000;//10 minutes
        setTimeout(function(){
            if(sessionStorage.refererURL !== undefined && sessionStorage.refererURL !== null){
            	console.log("!!!Redirecting to = " + sessionStorage.refererURL);
               window.location = sessionStorage.refererURL;
            }
         }, refreshInterval);
	}
);

function doSubmission(username, password) {
	var baseURL = window.location.origin;
        var xhrArgs = {
              url: baseURL+"<%=request.getContextPath()%>/j_security_check",
              content: {"j_username":username, "j_password":password},
              handleAs: "text",
              load: handleLoginSuccess,
              error: handleLoginError
        }
        var deferred = dojo.xhrPost(xhrArgs);
}

//This is login success from j_security_check call
function handleLoginSuccess(data,ioargs) {
    if (data === "<login>failed</login>") {
        //login failed
        populateResultMessage("oneuiMsgError16", "<%= getMessage("loginFailureMessage", currentLocale) %>", "messageDiv");
    }
    else if(data.toString().indexOf("function handleLogin()") != -1 && data.toString().indexOf("function doSubmission") != -1) {//check if login page was returned
        handleLogout();
        populateResultMessage("oneuiMsgError16", "<%= getMessage("loginInvalidPermission", new Locale("en", "US")) %>", "messageDiv");
    }
    else{
    	//Second layer to make sure there is no existing sessions for same user
    	var path = getRefererPath();                                                    
        if (path.indexOf("admin") != -1 || path.indexOf("console") != -1 || path.indexOf("standalone") != -1 || path.indexOf("manager") != -1) {//ocm and manager
        	var type = "manager";
        	if(path.indexOf("admin") != -1){
        		type = "OCM";
        	}
            var xhrArgs = {
                    url: "<%=request.getContextPath()%>/session",
                    content: {"userName":username.value, "type": type},
                    handleAs: "text",
                    load: handleSessionSuccess,
                    error: handleSessionError
              }
              var deferred = dojo.xhrPost(xhrArgs);
        }
        else {//application call
            window.location = path;
        }
    }
}

//This is login error from j_security_check call
function handleLoginError(data,ioargs){
    console.log("In handleLoginError data = " + data);
    if (data.toString().indexOf("403") != -1){
        //user doesn't have the correct role - this login page is no longer valid
        window.location.hash = username.value;
        window.location.reload();
    }
    else if(data.toString().indexOf("Unable to load") != -1){//Happens when browser cookies are cleared we get Unable to load https://localhost:8443/optim/j_security_check
    	window.location.reload();
    }
    else {
        console.log("<%= getMessage("loginFailureMessage", currentLocale) %>: ");
        populateResultMessage("oneuiMsgError16", "<%= getMessage("loginFailureMessage", currentLocale) %>", "messageDiv");
    }
}

function handleLogout() {
    var xhrArgs = {
            url: "<%=request.getContextPath()%>/ibm_security_logout",  
            handleAs: 'text',
            load: function(data){ console.log('load logout data = ' + data); },
            error: function(error){ console.log('error logout data = ' + data); }
    }
    dojo.xhrPost(xhrArgs);
}

//This is login success from /session api call (basically checks if there is simultaneous logins from same user)
function handleSessionSuccess(data, ioargs){
    var path = getRefererPath();
    var parser = new DOMParser();
    xmlDoc = parser.parseFromString(data, "text/xml");
    var lastLoggedInTime = xmlDoc.getElementsByTagName("lastLoggedInTime")[0].childNodes[0].nodeValue;
    localStorage.setItem('last-login-time', lastLoggedInTime);
    if (path.indexOf("admin") != -1) {
        window.location = "<%=request.getContextPath()%>/admin";
    }
    else if(path.indexOf("standalone") != -1 || path.indexOf("manager") != -1){
        window.location = "<%=request.getContextPath()%>/standalone";
    }
    else if (path.indexOf("console") != -1) {
        window.location = "<%=request.getContextPath()%>/console";
    }
    else {
        window.location = path;
    }
}

//This is login failure from /session api call. This is called when user tried to simultaneously login to application when there was a session already open.
function handleSessionError(error){
	if(error.status == 500){
		window.location = "<%=request.getContextPath()%>/Error500.jsp";
	} 
	else if(error.status == 403) {
	    window.location = "<%=request.getContextPath()%>/MultipleSessionError.jsp";
	}
	else{
		console.log("/sesion api -> status = " + error.status + " ; message = " + error.toString());
		window.location = "<%=request.getContextPath()%>/logout.jsp";
	}
}

function getRefererPath(){
	var path = "<%= path %>";
	return path;
}

function handleLogin() {
	var username;
	var password;
	require(["dojo/dom"], function(dom){
		username = dom.byId("username").value;
		password = dom.byId("password").value;
	});
	if (!username || !password) {
		populateResultMessage("oneuiMsgError16", "<%= getMessage("loginMandatoryMessage", currentLocale) %>", "messageDiv");
	} else {
		doSubmission(username, password);
	}
}

function populateResultMessage(imgClass, msg, div) {
	var result = formatResultTable(imgClass, msg);
	require(["dojo/dom"], function(dom){
		dom.byId(div).innerHTML = result;
	});
}

function displayProductName(){
	require(["dojo/dom"], function(dom){
		var path = getRefererPath();
        if(sessionStorage.refererURL === null || (sessionStorage.refererURL !== null && sessionStorage.refererURL !== path)){
            sessionStorage.refererURL = path;
        }
		var pageTitle = "";
		dom.byId("productTitleDisplayPrefix").innerHTML = "<%= getMessage("productTitlePrefix", currentLocale) %>";
		if ((path.indexOf("admin"))!= -1){
			dom.byId("productTitleDisplay").innerHTML = "<%= getMessage("ocmProductTitleSuffix", currentLocale) %>";
			pageTitle = "<%= ocmTitle %>";
		}else if((path.indexOf("console"))!= -1 || (path.indexOf("standalone"))!= -1 || (path.indexOf("manager"))!= -1) {
			dom.byId("productTitleDisplay").innerHTML = "<%= getMessage("managerProductTitleSuffix", currentLocale) %>";
			pageTitle = "<%= mgrTitle %>";
		}else {
			dom.byId("productTitleDisplay").innerHTML = "Login";
			pageTitle = "<%= applicationTitle %>";
		}
		document.title = pageTitle;
	});
}

function formatResultTable(imgClass, msg) {
	var resultTable = "<table style='border-style:none'><tr><td><div class='" + imgClass + "' /></td><td style='padding-left:5px'>" + msg + "</td></tr></table>"; 
	return resultTable; 
}

function handleCancel() {
	window.location = "<%=request.getContextPath()%>/admin/main.jsp";
}

function preLoad() {
	if (window.location.search) {
		populateResultMessage("oneuiMsgError16", "<%= getMessage("loginFailureMessage", currentLocale) %>", "messageDiv");
	}
	displayProductName();
}

function isEnter(event) {
	if (event.keyCode == 13) {
		handleLogin();
	}
}

</script>
    
</head>
<body class="oneui" onload="preLoad()">
	<div id="loadingDiv" class="loadingDiv pageOverlay"></div>
	<script>
		var preLoader;
		require(["dojo/_base/declare", 
		         "dojo/_base/fx", 
		         "dojo/dom", 
		         "dojo/dom-style"],
		function(declare, fx, dom, domStyle){
			var PreLoader = declare(null, {
				loadingNode: null,
				constructor: function(){
					this.loadingNode = dom.byId('loadingDiv');
				},
				loadComplete: function(){
					fx.fadeOut({
						node: this.loadingNode,
						onEnd: function(node){
							domStyle.set(node, 'display', 'none');
						}
					}).play();
				}
			});
			preLoader = new PreLoader();
		});
	</script>
	<div id="loginPageId" dojoType="idx.layout.BorderContainer" style="width: 100%; height: 100%;" gutters="false">
		<div dojoType="dijit.layout.ContentPane" region="center">
			<div class="idxLoginFrame">
			    <div class="idxLoginFrameBoxWithShadow">
			      <div class="idxLoginFrameBox">
			       <div class="idxLoginFrameBoxInner">
			          <div class="ibmLogo"></div>
			          <div class="idxLoginFrameTitle" style="margin-bottom:20px">
			          	<span id="productTitleDisplayPrefix"></span>
			          	<br/>
			          	<span id="productTitleDisplay"></span>
			          </div>
			          <div id="username" data-dojo-type="idx.form.TextBox" data-dojo-props='onKeyUp:isEnter, required: false' placeholder="<%= getMessage("userNameHint", currentLocale) %>" 
			             style="margin-bottom:20px;"></div>
			          <div id="password" data-dojo-type="idx.form.TextBox" type="password" data-dojo-props='onKeyUp:isEnter, required: false' style="margin-bottom:15px;" placeholder="<%= getMessage("passwordHint", currentLocale) %>"></div>
			          <div id="messageDiv"></div>
			          <div data-dojo-type="idx/layout/ButtonBar" style="margin-bottom:30px; margin-top:15px;">
							<div id="submitButton" data-dojo-type="dijit/form/Button" placement="special" data-dojo-props="onClick:handleLogin"><%= getMessage("loginButtonLabel", currentLocale) %></div>
							<div id="cancelButton" data-dojo-type="dijit/form/Button" placement="secondary" data-dojo-props="onClick:handleCancel"><%= getMessage("cancelButtonLabel", currentLocale) %></div>
	  				  </div>
			          <div data-dojo-attach-point="copyrightNode" class="legal"><%= getMessage("copyright", currentLocale) %></div>
			       </div>
			      </div>
			    </div>
			</div>
		</div>
	</div>
</body>
</html>
